## xrt 202610.2.21.21

=== CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2025 Advanced Micro Devices, Inc. All rights reserved.
cmake_minimum_required(VERSION 3.16.0)
project(XRT-UPSTREAM)

set(XRT_UPSTREAM_DEBIAN 1)
set(XRT_UPSTREAM 1)

add_subdirectory(xrt)
add_subdirectory(xdna)

=== xdna-driver/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2022-2025, Advanced Micro Devices, Inc. All rights reserved.

cmake_minimum_required(VERSION 3.19.0)
project("amd-xdna")
set(PROJECT_DESCRIPTION "AMD XDNA driver and SHIM for Linux")
option(SKIP_KMOD "Building and packaging SHIM without driver and firmware" 1)

if (DEFINED ENV{XRT_PLUGIN_VERSION_PATCH})
  SET(XRT_PLUGIN_VERSION_PATCH $ENV{XRT_PLUGIN_VERSION_PATCH})
else()
  SET(XRT_PLUGIN_VERSION_PATCH 0)
endif()

# Set install component that will be packaged
# Default install compoment will install to shim test area
set(XDNA_COMPONENT "amdxdna")

# Set destination paths in install command
# Relocatable by ${CMAKE_INSTALL_PREFIX}
include (GNUInstallDirs)
set(XDNA_PKG_DIR      .)
set(XDNA_PKG_LIB_DIR  ${XDNA_PKG_DIR}/${CMAKE_INSTALL_LIBDIR})
set(XDNA_PKG_DATA_DIR ${XDNA_PKG_DIR}/${CMAKE_INSTALL_DATADIR}/${XDNA_COMPONENT})
# Non-relocatable by ${CMAKE_INSTALL_PREFIX}
set(XDNA_PKG_FW_DIR   /usr/lib/firmware/amdnpu)
set(XDNA_BIN_DIR      /bins) # For saving all built artifacts for quick testing
message("-- XDNA_PKG_LIB_DIR=${XDNA_PKG_LIB_DIR}")
message("-- XDNA_PKG_DATA_DIR=${XDNA_PKG_DATA_DIR}")
message("-- XDNA_PKG_FW_DIR=${XDNA_PKG_FW_DIR}")
message("-- XDNA_BIN_DIR=${XDNA_BIN_DIR}")

if (XRT_UPSTREAM)
  include(CMake/upstream.cmake)
else()
  include(CMake/native.cmake)
endif()

=== XRT/src/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2018-2022 Xilinx, Inc. All rights reserved.
# Copyright (C) 2022 Advanced Micro Devices, Inc. All rights reserved.
cmake_minimum_required(VERSION 3.5...4.0)
project(XRT)
set(PROJECT_DESCRIPTION "https://github.com/Xilinx/XRT")

# Include utility functions
include(CMake/utilities.cmake)

# Include supporting CMake functions
include(CMake/unitTestSupport.cmake)

# Exported interface into XRT for include from implemenation
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/runtime_src
  ${CMAKE_CURRENT_SOURCE_DIR}/runtime_src/core/include
  ${CMAKE_CURRENT_SOURCE_DIR}/runtime_src/core/common/gsl/include
  ${XRT_BINARY_DIR}/gen
  ${XRT_BINARY_DIR}
  )

include(CMake/settings.cmake)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${XRT_SOURCE_DIR}/CMake/")

if (NOT XRT_EDGE)
  # Enable testing for this directory and below.  This command should be
  # in the source directory root because ctest expects to find a test
  # file in the build directory root.
  enable_testing()

  # Temporary native wrapper while Linux code is being ported to windows.
  # When completed the two build flows will once again be merged into one
  # common file
  if (WIN32)
    include(CMake/nativeWin.cmake)
  else()
    include(CMake/nativeLnx.cmake)
  endif()
  xrt_include(CMake/nativeTests.cmake)
else()
  include(CMake/embedded_system.cmake)
endif()

=== xdna-driver/src/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2022-2025, Advanced Micro Devices, Inc. All rights reserved.

if(XDNA_VE2)
add_subdirectory(shim_ve2)
else()

if(NOT SKIP_KMOD)
add_subdirectory(driver)
endif()

add_subdirectory(shim)
endif()

=== xdna-driver/test/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2024, Advanced Micro Devices, Inc. All rights reserved.

add_subdirectory(shim_test)
add_subdirectory(xrt_test)

=== XRT/src/python/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2021 Xilinx, Inc. All rights reserved.
# Copyright (C) 2025 Advanced Micro Devices, Inc. All rights reserved.
add_subdirectory(pybind11)

=== XRT/tests/mcdm/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2022 Xilinx, Inc. All rights reserved.
#
CMAKE_MINIMUM_REQUIRED(VERSION 3.0.0)
PROJECT(XRT_TESTCASES)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED OFF)
set(CMAKE_VERBOSE_MAKEFILE ON)
set(XILINX_XRT $ENV{XILINX_XRT})
set(XRT_CORE_LIBRARY xrt_core)

if (NOT DEFINED ${INSTALL_DIR})
  set(INSTALL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/build/${CMAKE_SYSTEM_NAME}/${CMAKE_BUILD_TYPE}/${MODE}")
endif()

add_subdirectory(probe)

=== XRT/tests/unit_test/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2022 Xilinx, Inc. All rights reserved.
#
CMAKE_MINIMUM_REQUIRED(VERSION 3.0.0)
PROJECT(UNIT_TEST)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED OFF)
set(CMAKE_VERBOSE_MAKEFILE ON)
set(XILINX_XRT $ENV{XILINX_XRT})
set(XRT_CORE_LIBRARY xrt_core)

if (MSVC)
  add_compile_options(/Zc:__cplusplus)
endif()

if (NOT DEFINED ${INSTALL_DIR})
  set(INSTALL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/build/${CMAKE_SYSTEM_NAME}/${CMAKE_BUILD_TYPE}/${MODE}")
endif()

add_subdirectory(001_basic_sincos)
add_subdirectory(002_bitonic_sort)
add_subdirectory(003_bringup0)
add_subdirectory(004_bringup1)
add_subdirectory(005_bringup2)
add_subdirectory(006_copy)
add_subdirectory(007_copy_loop)
add_subdirectory(008_globalbandwidth)
add_subdirectory(009_mmult1)
add_subdirectory(010_mmult2)
add_subdirectory(011_mmult3)
add_subdirectory(012_mmult4)
add_subdirectory(013_montecarlo)
add_subdirectory(014_multikernel)
add_subdirectory(015_outoforderqueue)
add_subdirectory(016_parkernels)
add_subdirectory(017_vectorswizzle)
add_subdirectory(018_bringup3)
add_subdirectory(019_bringup4)
add_subdirectory(036_hello)
add_subdirectory(2kernelglobal_002_rw_4ddr_512)
add_subdirectory(cdma)
add_subdirectory(cuselect)
add_subdirectory(subdevice)
add_subdirectory(vadd_bank3)

=== XRT/tests/unit_test/Makefile ===
#####################################################################################################################
# This makefile can be used to generate output files for all XRT example test
# To generate executable file run: make exe
# To generate xclbin file run: make xclbin
# To remove all the tests run: make clean
# To generate xclbin and exe files run: make all
# All generated output files locate in build/opt/$testcase where $testcase is testcase name
#####################################################################################################################
TARGETS := \
 001_basic_sincos \
 006_copy \
 011_mmult3 \
 016_parkernels \
 002_bitonic_sort \
 007_copy_loop \
 012_mmult4 \
 017_vectorswizzle \
 003_bringup0 \
 008_globalbandwidth \
 013_montecarlo \
 018_bringup3 \
 004_bringup1 \
 009_mmult1 \
 014_multikernel \
 019_bringup4 \
 005_bringup2 \
 010_mmult2 \
 015_outoforderqueue \
 036_hello

all:
	for t in $(TARGETS) ; do echo "Generating exe and xclbin files  .." ; cd  $$PWD/$$t ; make all  ;  cd .. ; done

clean:
	for t in $(TARGETS) ; do echo "Cleaning testcase .." ; cd  $$PWD/$$t ; make clean  ;  cd .. ; done

exe:
	for t in $(TARGETS) ; do echo "Compiling the host for test $$PWD/$$t .." ; cd  $$PWD/$$t ; make exe  ;  cd .. ;done

xclbin:
	for t in $(TARGETS) ; do echo "Creating xclbin for test  $$PWD/$$t .." ; cd  $$PWD/$$t ; make xclbin  ;  cd .. ; done

=== xdna-driver/src/driver/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2022-2025, Advanced Micro Devices, Inc. All rights reserved.

set(XDNA_DRV amdxdna)

set(XDNA_DRV_DIR amdxdna)
set(XDNA_DRV_TGT ${XDNA_DRV}.ko)
set(XDNA_DRV_PATH ${CMAKE_BINARY_DIR}/driver/${XDNA_DRV_TGT})
set(XDNA_DRV_BLD_DIR driver/${XDNA_DRV_DIR})
set(XDNA_DRV_BLD_SRC ${CMAKE_CURRENT_BINARY_DIR}/${XDNA_DRV_BLD_DIR})
set(XDNA_DRV_BLD_TGT ${CMAKE_CURRENT_BINARY_DIR}/${XDNA_DRV_DIR})

set(XDNA_DRV_PF amdxdna_pf)

set(XDNA_DRV_PF_DIR amdxdna_pf)
set(XDNA_DRV_PF_TGT ${XDNA_DRV_PF}.ko)
set(XDNA_DRV_PF_PATH ${CMAKE_BINARY_DIR}/driver/${XDNA_DRV_PF_TGT})
set(XDNA_DRV_PF_BLD_DIR driver/${XDNA_DRV_PF_DIR})
set(XDNA_DRV_PF_BLD_SRC ${CMAKE_CURRENT_BINARY_DIR}/${XDNA_DRV_PF_BLD_DIR})
set(XDNA_DRV_PF_BLD_TGT ${CMAKE_CURRENT_BINARY_DIR}/${XDNA_DRV_PF_DIR})

# Common flags used for both building driver and configuring dkms
if (DEFINED ENV{XDNA_DRV_BLD_FLAGS})
  set(XDNA_DRV_BLD_FLAGS_DKMS $ENV{XDNA_DRV_BLD_FLAGS})
  set(XDNA_DRV_BLD_FLAGS_MAKE $ENV{XDNA_DRV_BLD_FLAGS})
  separate_arguments(XDNA_DRV_BLD_FLAGS_MAKE)
endif(DEFINED ENV{XDNA_DRV_BLD_FLAGS})

message("-- Extra driver source dir: ${XDNA_EXTRA_DRV_DIR}")
message("-- Extra driver tar exclude rules: ${XDNA_EXTRA_DRV_EXCLUDES}")

add_custom_command(
  OUTPUT all_driver_source
  COMMENT "Collect all driver source code"
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $(CMAKE_COMMAND) -E make_directory ${XDNA_DRV_BLD_DIR}
  COMMAND cp -rf ${CMAKE_CURRENT_SOURCE_DIR}/${XDNA_DRV_DIR}/* ${XDNA_EXTRA_DRV_DIR} ${XDNA_DRV_BLD_DIR}
  COMMAND cp -r ${CMAKE_CURRENT_SOURCE_DIR}/../include .
  )

# Because ${XDNA_DRV_TGT} is generated in ${XDNA_DRV_BLD_TGT}. So this custom command will always run.
add_custom_command(
  OUTPUT ${XDNA_DRV_TGT}
  COMMENT "Build ${XDNA_DRV_TGT}"
  COMMAND $(MAKE) -f ${XDNA_DRV_BLD_SRC}/Makefile BUILD_ROOT_DIR=${XDNA_DRV_BLD_TGT} ${KERNEL_VER} UMQ_HELLO_TEST=${UMQ_HELLO_TEST} ${XDNA_DRV_BLD_FLAGS_MAKE} XDNA_BUS_TYPE=pci
  COMMAND $(MAKE) -f ${XDNA_DRV_BLD_SRC}/Makefile BUILD_ROOT_DIR=${XDNA_DRV_BLD_TGT} copy_ko
  COMMAND $(CMAKE_COMMAND) -E copy ${XDNA_DRV_BLD_TGT}/${XDNA_DRV_TGT} ${XDNA_DRV_PATH}
  DEPENDS all_driver_source
  )

add_custom_command(
  OUTPUT pf_driver_source
  COMMENT "Collect pf driver source code"
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $(CMAKE_COMMAND) -E make_directory ${XDNA_DRV_PF_BLD_DIR}
  COMMAND cp -rf ${XDNA_DRV_PF_SRC_DIR} ${XDNA_DRV_PF_BLD_DIR}
  #temporary workaround to grab common code for pf driver
  COMMAND cp ${XDNA_DRV_BLD_DIR}/amdxdna_mailbox.* ${XDNA_DRV_BLD_DIR}/amdxdna_trace.h ${XDNA_DRV_BLD_DIR}/aie4/aie4_msg_priv.h ${XDNA_DRV_PF_BLD_DIR}
  DEPENDS all_driver_source
)

# Build amdxdna_pf driver
add_custom_command(
  OUTPUT ${XDNA_DRV_PF_TGT}
  COMMENT "Build ${XDNA_DRV_PF_TGT}"
  COMMAND $(MAKE) -f ${XDNA_DRV_PF_BLD_SRC}/Makefile BUILD_ROOT_DIR=${XDNA_DRV_PF_BLD_TGT} ${KERNEL_VER} XDNA_BUS_TYPE=pci
  COMMAND $(MAKE) -f ${XDNA_DRV_PF_BLD_SRC}/Makefile BUILD_ROOT_DIR=${XDNA_DRV_PF_BLD_TGT} copy_ko
  COMMAND $(CMAKE_COMMAND) -E copy ${XDNA_DRV_PF_BLD_TGT}/${XDNA_DRV_PF_TGT} ${XDNA_DRV_PF_PATH}
  DEPENDS pf_driver_source
  )

if(XDNA_DRV_PF_SRC_DIR)
add_custom_target(driver ALL DEPENDS ${XDNA_DRV_TGT} ${XDNA_DRV_PF_TGT})
else()
add_custom_target(driver ALL DEPENDS ${XDNA_DRV_TGT})
endif()

# Tar and install driver source code for packaging
set(XDNA_DRV_SRC_DIR
  driver
  include
  )
set(XDNA_DRV_EXCLUDES
  --exclude=CMake*
  --exclude=tools
  --exclude=doc
  ${XDNA_EXTRA_DRV_EXCLUDES}
  )
file(GLOB_RECURSE ALL_DRV_FILES
  ${XDNA_DRV_BLD_SRC}/Makefile
  ${XDNA_DRV_BLD_SRC}/*.c
  ${XDNA_DRV_BLD_SRC}/*.h
  ${CMAKE_CURRENT_BINARY_DIR}/include/*.h
  )
set(XDNA_DRV_SRC_TGT ${XDNA_DRV}.tar)
add_custom_command(
  OUTPUT ${CMAKE_BINARY_DIR}/driver/${XDNA_DRV_SRC_TGT}
  COMMENT "Tar ${XDNA_DRV} driver source code"
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND tar ${XDNA_DRV_EXCLUDES} -cf ${CMAKE_CURRENT_BINARY_DIR}/${XDNA_DRV_SRC_TGT} ${XDNA_DRV_SRC_DIR}
  COMMAND $(CMAKE_COMMAND) -E copy ${CMAKE_CURRENT_BINARY_DIR}/${XDNA_DRV_SRC_TGT} ${CMAKE_BINARY_DIR}/driver/${XDNA_DRV_SRC_TGT}
  DEPENDS ${ALL_DRV_FILES}
  )

# Substitute driver version in the source code
set(XDNA_TAR_GZ ${XDNA_DRV}.tar.gz)
add_custom_command(
  OUTPUT ${CMAKE_BINARY_DIR}/driver/${XDNA_TAR_GZ}
  COMMENT "Substitute amdxdna module version and re-tar"
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/driver
  COMMAND $(CMAKE_COMMAND) -E make_directory tmp
  COMMAND tar xf ${CMAKE_BINARY_DIR}/driver/${XDNA_DRV_SRC_TGT} -C tmp
  COMMAND find tmp -name amdxdna_pci_drv.c -exec sed -i 's/MODULE_VERSION\(\".*\"\)/MODULE_VERSION\(\"${XRT_PLUGIN_VERSION_STRING}_${XDNA_DATE},${XDNA_HASH}\"\)/' {} \\\;
  COMMAND tar zcf ${CMAKE_BINARY_DIR}/driver/${XDNA_TAR_GZ} -C tmp .
  COMMAND $(CMAKE_COMMAND) -E rm -r tmp
  DEPENDS ${CMAKE_BINARY_DIR}/driver/${XDNA_DRV_SRC_TGT}
  )
add_custom_target(driver_ver_tarball ALL DEPENDS ${CMAKE_BINARY_DIR}/driver/${XDNA_TAR_GZ} driver)
install(FILES ${CMAKE_BINARY_DIR}/driver/${XDNA_TAR_GZ}
  DESTINATION ${XDNA_PKG_DATA_DIR}
  COMPONENT ${XDNA_COMPONENT}
  )

set(MAKE_DRV "cd driver/${XDNA_DRV_DIR}; make ${XDNA_DRV_BLD_FLAGS_DKMS} KERNEL_SRC=\${kernel_source_dir}; cd ../..")
set(CLEAN_DRV "cd driver/${XDNA_DRV_DIR}; make clean KERNEL_SRC=\${kernel_source_dir}; cd ../..")
set(MODULE_DRV "BUILT_MODULE_NAME[0]=${XDNA_DRV}
BUILT_MODULE_LOCATION[0]=\"driver/${XDNA_DRV_DIR}/build/driver/amdxdna\"
DEST_MODULE_LOCATION[0]=\"/kernel/extras\"")

if(XDNA_DRV_PF_SRC_DIR)
  set(MAKE_DRV "${MAKE_DRV}; cd driver/${XDNA_DRV_PF_DIR}; make KERNEL_SRC=\${kernel_source_dir}; cd ../..")
  set(CLEAN_DRV "${CLEAN_DRV}; cd driver/${XDNA_DRV_PF_DIR}; make clean KERNEL_SRC=\${kernel_source_dir}; cd ../..")
  set(MODULE_DRV "${MODULE_DRV}
BUILT_MODULE_NAME[1]=${XDNA_DRV_PF}
BUILT_MODULE_LOCATION[1]=\"driver/${XDNA_DRV_PF_DIR}/build/driver/amdxdna_pf\"
DEST_MODULE_LOCATION[1]=\"/kernel/extras\"")
endif(XDNA_DRV_PF_SRC_DIR)

# Install config file and driver related scripts for packaging
set(XDNA_DKMS_PKG_NAME xrt-${XDNA_DRV})
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/CMake/config/dkms.conf.in
  ${CMAKE_CURRENT_BINARY_DIR}/dkms.conf
  @ONLY
  )
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dkms.conf
  DESTINATION ${XDNA_PKG_DATA_DIR}
  COMPONENT ${XDNA_COMPONENT}
  )

# install .ko for testing
if(XDNA_DRV_PF_SRC_DIR)
  install(FILES ${XDNA_DRV_PATH} ${XDNA_DRV_PF_PATH} DESTINATION ${XDNA_BIN_DIR}/driver)
else()
  install(FILES ${XDNA_DRV_PATH} DESTINATION ${XDNA_BIN_DIR}/driver)
endif()

set(amdxdna_drv_tools
  ${CMAKE_CURRENT_SOURCE_DIR}/tools/dkms_driver.sh
  ${CMAKE_CURRENT_SOURCE_DIR}/tools/npu_perf_trace.sh
  ${CMAKE_CURRENT_SOURCE_DIR}/tools/npu_perf_analyze.sh
  ${CMAKE_CURRENT_SOURCE_DIR}/tools/io_page_fault_flags
  )
install(FILES ${amdxdna_drv_tools}
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
  DESTINATION ${XDNA_PKG_DATA_DIR}
  COMPONENT ${XDNA_COMPONENT}
  )

=== xdna-driver/src/shim/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2022-2025, Advanced Micro Devices, Inc. All rights reserved.

set(XDNA_TARGET xrt_driver_xdna)
set(XRT_CORE_TARGET xrt_core)
set(XRT_COREUTIL_TARGET xrt_coreutil)

aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR} MAIN_SOURCES)
aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR}/kmq KMQ_SOURCES)
aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR}/umq UMQ_SOURCES)
aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR}/host HOST_SOURCES)
aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR}/virtio VIRTIO_SOURCES)
add_library(${XDNA_TARGET} SHARED
  ${MAIN_SOURCES}
  ${KMQ_SOURCES}
  ${UMQ_SOURCES}
  ${HOST_SOURCES}
  ${VIRTIO_SOURCES}
  )

set_target_properties(${XDNA_TARGET} PROPERTIES
  VERSION ${XRT_PLUGIN_VERSION_STRING}
  SOVERSION ${XRT_SOVERSION}
  )

target_compile_definitions(${XDNA_TARGET} PRIVATE
  # below macros is required so that i/f defined in ishim.h is
  # consistent with native xrt implementation
  XRT_ENABLE_AIE
  XRT_AIE_BUILD
  XRT_BUILD
  )

if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
  add_definitions(-DXDNA_SHIM_DEBUG)
endif()

if(${UMQ_HELLO_TEST})
  add_definitions(-DUMQ_HELLO_TEST)
endif()

target_compile_options(${XDNA_TARGET} PRIVATE
  "-fPIC"
  )

target_include_directories(${XDNA_TARGET} PRIVATE
  ${XRT_SOURCE_DIR}/runtime_src
  ${XRT_SOURCE_DIR}/runtime_src/core/include
  ${XRT_SOURCE_DIR}/runtime_src/core/common/gsl/include
  ${XRT_BINARY_DIR}/gen
  ${CMAKE_CURRENT_SOURCE_DIR}/../include/uapi
  )

# driver plugin will be loaded while xrt_core is still being
# dlopen'ed, symbols against libxrt_core.so can't be solved
# at that time, so need to be fully solved here.
target_link_libraries(${XDNA_TARGET} PRIVATE
  xrt_core
  ${XRT_CORE_TARGET}
  ${XRT_COREUTIL_TARGET}
  )

target_link_options(${XDNA_TARGET} PRIVATE
  "-Wl,-z,defs"
  )

# install components for packaging
install(TARGETS ${XDNA_TARGET}
  LIBRARY DESTINATION ${XDNA_PKG_LIB_DIR}
  NAMELINK_SKIP
  COMPONENT ${XDNA_COMPONENT}
  )

# install components for testing
install(TARGETS ${XRT_CORE_TARGET} DESTINATION ${XDNA_BIN_DIR}/${XDNA_PKG_LIB_DIR})
install(TARGETS ${XRT_COREUTIL_TARGET} DESTINATION ${XDNA_BIN_DIR}/${XDNA_PKG_LIB_DIR})
install(TARGETS ${XDNA_TARGET} DESTINATION ${XDNA_BIN_DIR}/${XDNA_PKG_LIB_DIR})

=== xdna-driver/src/shim_ve2/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2025, Advanced Micro Devices, Inc. All rights reserved.

include_directories(
  ${DRM_INCLUDE_DIRS}
  ${CMAKE_BINARY_DIR} # include gen/version.h
  )

file(GLOB XRT_EDGE_USER_FILES "*.cpp")

set(XDNA_VE2_TARGET xrt_driver_xdna)

aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR} MAIN_SOURCES)

set(CMAKE_CXX_FLAGS "-DXCLHAL_MAJOR_VER=2 ${CMAKE_CXX_FLAGS}")
set(CMAKE_CXX_FLAGS "-DXCLHAL_MINOR_VER=1 ${CMAKE_CXX_FLAGS}")

# Bypass binary targets if clangtidy is enabled,
# same targets are defined for DC
if (${XRT_CLANGTIDY_REVIEW})
  return()
endif()

add_library(${XDNA_VE2_TARGET} SHARED ${MAIN_SOURCES})

set_target_properties(${XDNA_VE2_TARGET} PROPERTIES VERSION ${XRT_VERSION_STRING}
  SOVERSION ${XRT_SOVERSION})

target_link_libraries(${XDNA_VE2_TARGET} PRIVATE
  xrt_core
  xrt_coreutil
  )

install (TARGETS ${XDNA_VE2_TARGET} 
  EXPORT xrt-targets 
  LIBRARY DESTINATION ${XRT_INSTALL_LIB_DIR}
  )

set(vtd_file "${CMAKE_CURRENT_BINARY_DIR}/xrt_smi_ve2.ar")

file(DOWNLOAD
  "https://github.com/Xilinx/VTD/raw/66cd853d8c2002e9059a749fbbd34b58cc8674da/archive/ve2/xrt_smi_ve2.a"
  "${vtd_file}"
)

install(FILES "${vtd_file}"
  DESTINATION ${CMAKE_INSTALL_DATADIR}/amdxdna/bins/
)

=== debian/control ===
Source: xrt
Section: libs
Priority: optional
Maintainer: Debian Xilinx Package Maintainers <team+pkg-xilinx@tracker.debian.org>
Uploaders: Punit Agrawal <punit@debian.org>,
	   Nobuhiro Iwamatsu <iwamatsu@debian.org>,
	   Mario Limonciello <superm1@debian.org>,
Build-Depends: cmake,
	debhelper-compat (= 13),
	appstream,
	bash-completion,
	dh-dkms,
	dh-python,
	doxygen [amd64],
	git,
	libboost-filesystem-dev,
	libboost-program-options-dev,
	libboost-system-dev,
	libcurl4-openssl-dev,
	libdrm-dev,
	libncurses-dev,
	libprotobuf-dev,
	libssl-dev,
	libudev-dev,
	libyaml-dev,
	lsb-release [amd64],
	ocl-icd-opencl-dev,
	ocl-icd-dev,
	pkgconf,
	protobuf-compiler,
	pybind11-dev,
	python3-dev,
	rapidjson-dev,
	systemtap-sdt-dev,
	uuid-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://www.xilinx.com/products/design-tools/vitis/xrt.html
Vcs-Git: https://salsa.debian.org/xilinx-packages-team/xrt.git
Vcs-Browser: https://salsa.debian.org/xilinx-packages-team/xrt

Package: libxrt2
Architecture: arm64 amd64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libxrt1 (<< ${binary:Version})
Conflicts: libxrt1
Replaces: libxrt1
Description: Xilinx Runtime (XRT) - runtime libraries
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides the runtime environment for xrt.

Package: libxrt-npu2
Architecture: arm64 amd64
Multi-Arch: same
Depends: ${misc:Depends},
	 ${shlibs:Depends},
Breaks: libxrt2 (<< 202520.2.20.172-1)
Description: Xilinx Runtime (XRT) - runtime libraries
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides the runtime environment for XRT NPU.

Package: libxrt-alveo2
Architecture: arm64 amd64
Multi-Arch: same
Depends: ${misc:Depends},
	 ${shlibs:Depends},
Breaks: libxrt2 (<< 202520.2.20.172-1)
Description: Xilinx Runtime (XRT) - runtime libraries
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides the runtime environment for XRT Alveo.

Package: python3-xrt
Architecture: arm64 amd64
Section: python
Depends: ${misc:Depends},
	 ${shlibs:Depends},
	 ${python3:Depends},
	 libxrt2 (= ${binary:Version})
Description: Xilinx Runtime (XRT) - Python bindings
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides Python bindings for XRT.

Package: libxrt-dev
Architecture: arm64 amd64
Section: libdevel
Multi-Arch: same
Depends: ${misc:Depends},
	 ${shlibs:Depends},
	 libxrt2 (= ${binary:Version})
Description: Xilinx Runtime (XRT) - development files
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides the development environment for xrt.

Package: libxrt-utils
Architecture: arm64 amd64
Section: utils
Depends: ${misc:Depends},
	 ${shlibs:Depends},
	 python3,
Description: Xilinx Runtime (XRT) - runtime -- utilities
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package contains utilities from the xrt project.

Package: libxrt-utils-npu
Architecture: arm64 amd64
Section: utils
Depends: ${misc:Depends},
	 ${shlibs:Depends},
	 libxrt-utils,
	 libxrt-npu2 (= ${binary:Version})
Description: Xilinx Runtime (XRT) - runtime -- utilities
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package contains a utilities from the XRT NPU project.

Package: libxrt-utils-alveo
Architecture: arm64 amd64
Section: utils
Depends: ${misc:Depends},
	 ${shlibs:Depends},
	 libxrt-utils,
	 libxrt-alveo2 (= ${binary:Version})
Description: Xilinx Runtime (XRT) - runtime -- utilities
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package contains a utilities from the XRT Alveo project.

Package: xrt-xocl-dkms
Architecture: amd64
Depends: ${misc:Depends},
	 ${shlibs:Depends},
	 dkms
Description: Xilinx Runtime (XRT) - runtime -- utilities
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package contains the XOCL DKMS kernel drivers.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

BUILDDIR := obj-$(shell dpkg-architecture -q DEB_HOST_GNU_TYPE)

CONFIGURE_ARGS = -DCMAKE_BUILD_TYPE=Release -DXRT_NPU=1 -DXRT_ALVEO=1

%:
	dh $@ --with bash-completion --with python3 --sourcedir=.

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_ARGS)

override_dh_auto_install:
	dh_auto_install

	# Alveo HW emulation only for amd64
	if [ "$(DEB_HOST_ARCH)" = "amd64" ] ; then \
	  mkdir -p debian/libxrt-alveo2/usr/lib/$(DEB_HOST_GNU_TYPE); \
	  mv debian/tmp/usr/lib/$(DEB_HOST_GNU_TYPE)/libxrt_hwemu*.so.* debian/libxrt-alveo2/usr/lib/$(DEB_HOST_GNU_TYPE); \
	fi

	# udev rules
	mkdir -p debian/xrt-xocl-dkms/usr/lib/udev/rules.d
	install -m 644 xrt/XRT/src/runtime_src/core/pcie/driver/linux/xocl/mgmtpf/99-xclmgmt.rules debian/xrt-xocl-dkms/usr/lib/udev/rules.d
	install -m 644 xrt/XRT/src/runtime_src/core/pcie/driver/linux/xocl/userpf/99-xocl.rules debian/xrt-xocl-dkms/usr/lib/udev/rules.d
	# dkms postinst/prerm hooks
	dh_dkms -pxrt-xocl-dkms -- $(BUILDDIR)/xrt/XRT/src/dkms.conf
	# Overwrite xbtop wrapper script
	mv debian/tmp/usr/python/xbtop.py debian/tmp/usr/bin/xbtop

override_dh_auto_test:
	make -C $(BUILDDIR) install DESTDIR=`pwd`/$(BUILDDIR) # xrt-smi and xbmgmt tests require install
	dh_auto_test

=== debian/watch ===
Version: 5
Source: https://api.github.com/repos/Xilinx/xrt/releases?per_page=100
Matching-Pattern: https://github.com/Xilinx/XRT/releases/download/@ANY_VERSION@/.*@ANY_VERSION@@ARCHIVE_EXT@
Repack: no
Searchmode: plain
